#!/usr/bin/perl -w -I/usr/sausalito/perl/

use strict;
use CCE;

my $cce=new CCE;
$cce->connectfd();
my $obj=$cce->event_object();

my $dhclientLeased = "/var/state/dhcp/LEASED";
my $configFile = "/etc/dhclient.conf";
my $count;



if($obj->{bootproto} ne "dhcp" || not $obj->{enabled}){

	killDhclient();

        $cce->bye("SUCCESS");
}else{
	#interface dhcp'd

	killDhclient();

       system("rm -f $dhclientLeased-$obj->{device}");
       if(!fork()){
	       #child
	       exec("/sbin/dhclient -cf ".$configFile.".$obj->{device} $obj->{device}");
		#see dhclient.pl for the reasoning behind per-interface config files.
	       exit 0;
       }


	while(!-e "$dhclientLeased-$obj->{device}"){
	       sleep(1);
               last if ++$count >=60;
        }
 
        if(-e "$dhclientLeased-$obj->{device}"){
                $cce->bye("SUCCESS");
        }else{
		killDhclient();
        	$cce->warn("[[base-dhclient.".$obj->{device}."Timeout]]");
		$cce->bye("FAIL");
         }
 
}                                                                               

sub killDhclient{

#darn screwey ps -fC cuts off process listings at 80 chars.
# good point but lets do this instead since we only need
# pid and cmd name, otherwise if there is some random command
# that has eth0 or eth1 in it (I know slim chance, but possible.)
# we don't end up killing it

	my $ps = `/bin/ps --no-headers -o "pid cmd" -C dhclient`;

        if($ps){
       	        my @dhclient = split/\n/,$ps;
                	if(($_)=grep {/$obj->{device}/} @dhclient){
                	s/^\s+//;
        	        my $pid=(split/\s+/)[0];
       	        	unless(kill 15,$pid){ #try being polite first (SIGTERM)
		                kill 9,$pid; #die, damnit. (SIGKILL)
			}
       	        }
	}
}

exit(0);
